<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<xsl:output method="html" encoding="ISO-8859-1"/>
<xsl:template match="/">

    <HTML>
      <HEAD>
        <TITLE><xsl:value-of select="reportContext/@productFamily"/> Report</TITLE>
        <STYLE TYPE="text/css" MEDIA="all">@import url("hello2morrow.css");</STYLE>
      </HEAD>
      <BODY>
        <TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="0">
          <TR>
            <!-- Navigation column -->
            <TD WIDTH="130" BGCOLOR="#333333">
              <IMG SRC="spacer.gif" ALT="" WIDTH="130" HEIGHT="65" BORDER="0"/>
            </TD>
            <!-- Whitespace column -->
            <TD WIDTH="23" BGCOLOR="E3E4E5">
              <IMG SRC="spacer.gif" WIDTH="23" HEIGHT="1"/>
            </TD>
            <!-- Content column -->
            <TD WIDTH="100%" BGCOLOR="E3E4E5">
              <TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0">
                <TR>
                  <TD WIDTH="7" BGCOLOR="E3E4E5">
                    <IMG SRC="spacer.gif" WIDTH="7" HEIGHT="1"/>
                  </TD>
                  <TD>
                    <IMG SRC="hello2morrow.gif" ALT="hello2morrow" WIDTH="227" HEIGHT="23" BORDER="0"/>
                  </TD>
                  <TD WIDTH="100%" ALIGN="right" BGCOLOR="E3E4E5">
                    <IMG SRC="header.gif" ALT="hello2morrow" WIDTH="543" HEIGHT="65" BORDER="0"/>
                  </TD>
                </TR>
              </TABLE>
            </TD>
          </TR>
          <!-- Horizontal black line -->
          <TR>
            <TD COLSPAN="3" BGCOLOR="#000000">
              <IMG SRC="spacer.gif" ALT="" WIDTH="1" HEIGHT="1" BORDER="0"/>
            </TD>
          </TR>
          <TR>
            <!-- Navigation column -->
            <TD BGCOLOR="#A7A9AC" valign="top">
            <TABLE CELLSPACING="3" >
              <TR>
                <TD WIDTH="130" HEIGHT="20" BGCOLOR="#A7A9AC">
                  <IMG SRC="spacer.gif" ALT="" WIDTH="130" HEIGHT="20" BORDER="0"/>
                </TD>
              </TR>
              <TR>
                <TD><A HREF="#projectContext"><B><FONT SIZE="1" COLOR="#FFFFFF">Project Context</FONT></B></A></TD>
              </TR>              
              <TR>
                <TD><A HREF="#projects"><B><FONT size="1" COLOR="#FFFFFF">Projects</FONT></B></A></TD>
              </TR>
              <TR>
                <TD><A HREF="#workspaces"><B><FONT size="1" COLOR="#FFFFFF">Workspaces</FONT></B></A></TD>
              </TR>              
              <TR>
                <TD><A HREF="#metric table"><B><FONT size="1" COLOR="#FFFFFF">Metric Table</FONT></B></A></TD>
              </TR>
              <TR>
                <TD><A HREF="#violations"><B><FONT size="1" COLOR="#FFFFFF">Violations (<xsl:value-of select="reportContext/violations/@numberOf"/>)</FONT></B></A></TD>
              </TR>
              <TR>
                <TD>
                  <A HREF="#warnings"><B><FONT SIZE="1" COLOR="#FFFFFF">Warnings (<xsl:value-of select="reportContext/warnings/@numberOf"/>)</FONT></B></A>
                </TD>
              </TR>
              <xsl:for-each select="reportContext/warnings/warningsByAttributeGroup">
              <TR>
                <TD>
                  <IMG SRC="spacer.gif" ALT="" WIDTH="20" HEIGHT="1" BORDER="0"/>
                  <A HREF="#warnings{@attributeGroup}"><B><FONT SIZE="0" COLOR="#FFFFFF"><xsl:value-of select="@attributeGroup"/> (<xsl:value-of select="@numberOf"/>)</FONT></B></A>
                </TD>
              </TR>
              </xsl:for-each>
              <TR>
                <TD><A HREF="#tasks"><B><FONT size="1" COLOR="#FFFFFF">Tasks (<xsl:value-of select="reportContext/tasks/@numberOf"/>)</FONT></B></A></TD>
              </TR>
              <TR>
                  <IMG SRC="spacer.gif" ALT="" WIDTH="20" HEIGHT="1" BORDER="0"/>
                <TD><A HREF="#exclusions"><B><FONT SIZE="1" COLOR="#FFFFFF">Exclusions</FONT></B></A></TD>
              </TR>
              <xsl:for-each select="reportContext/exclusions">
              <TR>
                <TD>
                  <IMG SRC="spacer.gif" ALT="" WIDTH="20" HEIGHT="1" BORDER="0"/>
                  <A HREF="#exclusions{@name}"><B><FONT SIZE="0" COLOR="#FFFFFF"><xsl:value-of select="@name"/> (<xsl:value-of select="@numberOf"/>)</FONT></B></A>
                </TD>
              </TR>
              </xsl:for-each>
            </TABLE>
            </TD>
            <!-- Whitespace column -->
            <TD WIDTH="23">
              <IMG SRC="spacer.gif" WIDTH="23" HEIGHT="1"/>
            </TD>
            <!-- Content column -->
            <TD WIDTH="100%">
              <TABLE WIDTH="100%" border="0">
                <TR>
                  <TD WIDTH="1%" HEIGHT="80" VALIGN="center">
                    <IMAGE SRC="{reportContext/@productFamily}.gif" WIDTH="150"/>
                  </TD>
                </TR>
                <TR>
                  <TD>
                    <H1 ID="projectContext">ProjectContext: <xsl:value-of select="reportContext/@name"/></H1>
                  </TD>
                </TR>
                <TR>
                  <TD>
                    <TABLE BORDER="0" CELLSAPCING="0" CELLPADDING="0" WIDTH="50%">
                      <xsl:for-each select="reportContext/general/attribute">
                        <B><xsl:value-of select="@name"/>: </B>
                        <xsl:value-of select="@value"/>
                        <BR/>
                      </xsl:for-each>
                    </TABLE>
                  </TD>
                </TR>
                <TR class="a"><TD/></TR>
                <TR>
                  <TD>
					  <TABLE CLASS="techTable" WIDTH="50%">
				          <TR>
				            <TH width="450">Name</TH>
				            <TH width="250">Value</TH>
				          </TR>
					    <xsl:for-each select="reportContext/attributes/attribute">
				          <TR><xsl:attribute name="class"><xsl:choose><xsl:when test="position() mod 2 = 0">b</xsl:when><xsl:otherwise>a</xsl:otherwise></xsl:choose></xsl:attribute>
					        <TD width="450">
					          <xsl:value-of select="@name"/>
					        </TD>
					        <TD width="250">
					          <xsl:value-of select="@value"/>
					        </TD>
					      </TR> 
					    </xsl:for-each>
					  </TABLE>
                  </TD>
                </TR>
              </TABLE>
            </TD>
          </TR>
          <TR>
            <!-- Navigation column -->
            <TD WIDTH="130" bgcolor="#A7A9AC">
              <IMG SRC="spacer.gif" ALT="" WIDTH="130" HEIGHT="65" BORDER="0"/>
            </TD>
            <!-- Whitespace column -->
            <TD WIDTH="23">
              <IMG SRC="spacer.gif" WIDTH="23" HEIGHT="1"/>
            </TD>
            <!-- Content column -->
            <TD WIDTH="100%">
              <TABLE WIDTH="100%" border="0">
                <TR>
                  <TD WIDTH="100%">
                    <xsl:apply-templates/>
                  </TD>
                </TR>
              </TABLE>
            </TD>
          </TR>
        </TABLE>
      </BODY>
    </HTML>
</xsl:template>

<xsl:template match="reportContext">
  <BR/>
  <H2 id="projects">Projects <A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A></H2>
  
  <TABLE CLASS="techTable" WIDTH="50%">
    <xsl:for-each select="projects/project">
      <xsl:choose>
        <xsl:when test="position() = 1">
          <TR>
            <TH width="250">Project</TH>
            <TH width="550">Description</TH>
          </TR>
        </xsl:when>
      </xsl:choose>
      <TR><xsl:attribute name="class"><xsl:choose><xsl:when test="position() mod 2 = 0">b</xsl:when><xsl:otherwise>a</xsl:otherwise></xsl:choose></xsl:attribute>
        <TD>
		  <xsl:value-of select="@name"/>
        </TD>
        <TD>
		  <xsl:value-of select="@description"/>
        </TD>
      </TR>
    </xsl:for-each>
  </TABLE>
  
  <BR/>
  
  <H2 id="workspaces">Workspaces <A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A></H2>
  
  <TABLE CLASS="techTable" WIDTH="75%">
    <xsl:for-each select="workspaces/workspace/workspacePath">
      <xsl:choose>
        <xsl:when test="position() = 1">
          <TR>
            <TH width="250">Project</TH>
            <TH width="250">Workspace path</TH>
            <TH width="550">Description</TH>
          </TR>
        </xsl:when>
      </xsl:choose>
      <TR><xsl:attribute name="class"><xsl:choose><xsl:when test="position() mod 2 = 0">b</xsl:when><xsl:otherwise>a</xsl:otherwise></xsl:choose></xsl:attribute>
        <TD>
		  <xsl:value-of select="../@project"/>
        </TD>
        <TD>
		  <xsl:value-of select="@path"/>
        </TD>
        <TD>
		  <xsl:value-of select="@description"/>
        </TD>
      </TR>
    </xsl:for-each>
  </TABLE>
  
  <BR/>
  
	  <H2 id="metric table">Metric Table <A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A></H2>
	  <TABLE CLASS="techTable"><xsl:attribute name="width"><xsl:choose><xsl:when test="count(//projects/project) > 1">90%</xsl:when><xsl:otherwise>50%</xsl:otherwise></xsl:choose></xsl:attribute>
		  <TR>
		    <TH>Project</TH>
		    <xsl:for-each select="projects/project">
		     <TH><xsl:value-of select="@name"/></TH>
		    </xsl:for-each>           
		  </TR>
	    <xsl:for-each select="projects/project[1]/attribute">
	      <xsl:variable name="index" select="position()"/>
	      <TR><xsl:attribute name="class"><xsl:choose><xsl:when test="position() mod 2 = 0">b</xsl:when><xsl:otherwise>a</xsl:otherwise></xsl:choose></xsl:attribute>
	        <TD>
	          <xsl:if test="count(//projects/project) > 1">
	            <a href="#metric {@name}"><b><xsl:value-of select="@name"/></b></a>
	          </xsl:if>  
	          <xsl:if test="count(//projects/project) = 1">
	            <b><xsl:value-of select="@name"/></b>
	          </xsl:if>  
	        </TD>
	    	<xsl:for-each select="../../project">
	          <TD align="right">
	            <xsl:value-of select="attribute[$index]/@value"/>
	          </TD>
	        </xsl:for-each>
	      </TR> 
	    </xsl:for-each>
	  </TABLE>
	  
	  <BR/>
  
  <xsl:if test="count(//projects/project) > 1">
  <xsl:for-each select="projects/project[1]/attribute">
    <xsl:variable name="index" select="position()"/>
    <xsl:variable name="metricName" select="@name"/>
    <xsl:variable name="description" select="//metric[@name=$metricName]/@description"/>
    <xsl:variable name="sorting" select="//metric[@name=$metricName]/@sort"/>

  <H3 id="metric {@name}">
    <xsl:value-of select="@name"/><xsl:text> </xsl:text><A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A>
  </H3>
    <B>Attribute description: </B><xsl:value-of select="//metric[@name=$metricName]/@description"/>
  <TABLE CLASS="techTable" WIDTH="30%">
    <TR>
      <TH width="250">Project</TH>
      <TH width="60">Value</TH>
    </TR>
    <!-- xsl:sort does not like order attribute to be set at runtime -->
    <xsl:choose><xsl:when test="$sorting='descending'">
    <xsl:for-each select="../../project">
        <xsl:sort select="attribute[$index]/@value" data-type="number" order="descending"/>
          <TR><xsl:attribute name="class"><xsl:choose><xsl:when test="position() mod 2 = 0">b</xsl:when><xsl:otherwise>a</xsl:otherwise></xsl:choose></xsl:attribute>
	        <TD>
	          <xsl:value-of select="@name"/>
	        </TD>
	        <TD align="right">
	          <xsl:value-of select="attribute[$index]/@value"/>
	        </TD>
	      </TR> 
    </xsl:for-each>
    </xsl:when>
    <xsl:otherwise>
    <xsl:for-each select="../../project">
        <xsl:sort select="attribute[$index]/@value" data-type="number" order="ascending"/>
          <TR><xsl:attribute name="class"><xsl:choose><xsl:when test="position() mod 2 = 0">b</xsl:when><xsl:otherwise>a</xsl:otherwise></xsl:choose></xsl:attribute>
	        <TD>
	          <xsl:value-of select="@name"/>
	        </TD>
	        <TD align="right">
	          <xsl:value-of select="attribute[$index]/@value"/>
	        </TD>
	      </TR> 
    </xsl:for-each>
    </xsl:otherwise></xsl:choose>
  </TABLE>
  </xsl:for-each>
  
  <BR/>
   </xsl:if>
  
  <H2 ID="violations">Violations (<xsl:value-of select="violations/@numberOf"/> / <xsl:value-of select="violations/@numberOfViolatingTypeRelations"/> type relations out of <xsl:value-of select="violations/@numberOfTypeRelations"/> / <xsl:value-of select="violations/@percentageOfViolatingTypeRelations"/>%) <A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A></H2>
  
    <TABLE CLASS="techTable" WIDTH="90%">
	  <xsl:for-each select="violations/architectureViolations">
	    <xsl:choose>
        <xsl:when test="position() = 1">
	      <TR>
	        <TH WIDTH="150">From Scope</TH>
	        <TH WIDTH="150">Element type</TH>
	        <TH>From</TH>
	        <TH>To</TH>
	        <TH WIDTH="150">To Scope</TH>
	        <TH>Type relations</TH>
	      </TR>
        </xsl:when>
	    </xsl:choose>
       <xsl:for-each select="architectureViolation">
		<TR CLASS="violation">
		  <xsl:for-each select="attribute">
			<TD>
			  <xsl:value-of select="@value"/>
			</TD>
		  </xsl:for-each>
		</TR>
	   </xsl:for-each>
		<TR>
			<TD></TD> 
			<TD></TD> 
			<TD bgcolor="#FFBBCC" colspan="2"><xsl:value-of select="@explanation"/></TD>
		</TR>
      <xsl:for-each select="typeRelation">
      <xsl:sort select="attribute[1]/@value" order="ascending"/>
        <xsl:choose>
          <xsl:when test="position() mod 2 = 0">
            <TR CLASS="b">
              <TD/><TD/>
              <xsl:for-each select="attribute">
                <TD>
                  <xsl:value-of select="@value"/>
                </TD>
              </xsl:for-each>
              <TD/><TD/>
            </TR>
          </xsl:when>
          <xsl:otherwise>
            <TR CLASS="a"><TD/></TR>
            <TR CLASS="a">
              <TD/><TD/>
              <xsl:for-each select="attribute">
                <TD>
                  <xsl:value-of select="@value"/>
                </TD>
              </xsl:for-each>
              <TD/><TD/>
            </TR>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:for-each>
      </xsl:for-each>
    </TABLE>
    <BR/>
  <BR/>

  <H2 ID="warnings">Warnings (<xsl:value-of select="warnings/@numberOf"/>) <A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A></H2>
  <xsl:for-each select="warnings/warningsByAttributeGroup">
  <H3 ID="warnings{@attributeGroup}"><xsl:value-of select="@attributeGroup"/> warnings (<xsl:value-of select="@numberOf"/>) 
    <A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A>
  </H3>
  
  <xsl:for-each select="warningsByAttribute">
    <B>Attribute name: </B>
    <xsl:value-of select="@attributeName"/> (<xsl:value-of select="@numberOf"/>)
    <BR/>
    <B>Attribute description: </B>
    <xsl:value-of select="@attributeDescription"/>
    <TABLE CLASS="techTable" WIDTH="90%">
      <TR>
        <TH WIDTH="200">Project</TH>
        <TH WIDTH="150">Element type</TH>
        <TH>Element</TH>
        <TH>Attribute value</TH>
      </TR>
      <xsl:for-each select="warning">
      <xsl:sort select="attribute[1]/@value" order="ascending"/>
      <xsl:sort select="attribute[2]/@value" order="ascending"/>
      <xsl:sort select="attribute[3]/@value" order="ascending"/>
      
        <TR><xsl:attribute name="class"><xsl:choose><xsl:when test="position() mod 2 = 0">b</xsl:when><xsl:otherwise>a</xsl:otherwise></xsl:choose></xsl:attribute>
          <xsl:for-each select="attribute">
            <TD>
              <xsl:value-of select="@value"/>
            </TD>
          </xsl:for-each>
        </TR>
      </xsl:for-each>
    </TABLE>
    <BR/>
  </xsl:for-each>
  </xsl:for-each>
  <BR/>
  
  <H2 ID="tasks">Tasks (<xsl:value-of select="tasks/@numberOf"/>) <A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A></H2>
    <TABLE CLASS="techTable" WIDTH="90%">
      <xsl:for-each select="tasks/task">
      <xsl:sort select="attribute[1]/@value" order="ascending"/>
      <xsl:sort select="attribute[2]/@value" order="ascending"/>
      <xsl:sort select="attribute[3]/@value" order="ascending"/>
	    <xsl:choose>
        <xsl:when test="position() = 1">
	      <TR>
	        <TH WIDTH="200">Project</TH>
	        <TH>Element type</TH>
	        <TH>Element</TH>
	        <TH>Description</TH>
	        <TH>Priority</TH>
	        <TH>Assigned to</TH>
	      </TR>
        </xsl:when>
	    </xsl:choose>
            <TR><xsl:attribute name="class"><xsl:choose><xsl:when test="position() mod 2 = 0">b</xsl:when><xsl:otherwise>a</xsl:otherwise></xsl:choose></xsl:attribute>
              <xsl:for-each select="attribute">
                <TD>
                  <xsl:value-of select="@value"/>
                </TD>
              </xsl:for-each>
            </TR>
      </xsl:for-each>
    </TABLE>
  <BR/>
  
  <H2 ID="exclusions">Exclusions <A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A></H2>
  <xsl:for-each select="exclusions">
  <H3 ID="exclusions{@name}">Excluded <xsl:value-of select="@name"/> types (<xsl:value-of select="@numberOf"/>) 
    <A HREF="#top"><FONT SIZE="1" COLOR="#9999FF">[TOP]</FONT></A>
  </H3>
    <TABLE CLASS="techTable" WIDTH="90%">
      <TR>
        <TH WIDTH="200">Scope</TH>
        <TH>Type</TH>
      </TR>
      <xsl:for-each select="excludedType">
      <xsl:sort select="attribute[1]/@value" order="ascending"/>
      <xsl:sort select="attribute[2]/@value" order="ascending"/>
        <TR><xsl:attribute name="class"><xsl:choose><xsl:when test="position() mod 2 = 0">b</xsl:when><xsl:otherwise>a</xsl:otherwise></xsl:choose></xsl:attribute>
          <xsl:for-each select="attribute">
            <TD>
              <xsl:value-of select="@value"/>
            </TD>
          </xsl:for-each>
        </TR>
      </xsl:for-each>
    </TABLE>
  </xsl:for-each>

</xsl:template>
</xsl:stylesheet>
